----------------------------------------------------------------------------------
-- car_alarm_tb.vhd
-- testbench for car_alarm.vhd
-- CBP 03-01-23 Revised Version
----------------------------------------------------------------------------------

  LIBRARY ieee;
  USE ieee.std_logic_1164.ALL;
  USE ieee.numeric_std.ALL;

  ENTITY car_alarm_tb IS
  END car_alarm_tb;

  ARCHITECTURE behavioral OF car_alarm_tb IS 

  -- Component Declaration
  COMPONENT car_alarm
    Port ( KDU : in STD_LOGIC_VECTOR (2 downto 0);
           Horn : out STD_LOGIC);
  END COMPONENT;

	signal KDU : std_logic_vector (2 downto 0) := "000";
    
    signal Horn : std_logic;
    
       
  BEGIN

  -- Component Instantiation
        uut: car_alarm PORT MAP(
			KDU => KDU,
			Horn => Horn
          );

	
  --  Stimulus process
    stim_process : PROCESS
     BEGIN
		KDU <= "000";
        wait for 50 ns;
		KDU <= "001";
        wait for 50  ns;
		KDU <= "010";
        wait for 50  ns;
		KDU <= "011";
        wait for 50  ns;
		KDU <= "100";
        wait for 50  ns;
		KDU <= "101";
        wait for 50  ns;
		KDU <= "110";
        wait for 50  ns;
		KDU <= "111";
		wait for 50  ns;
		KDU <= "110";
		wait for 50 ns;
		KDU <= "101";
		wait for 50  ns;
		KDU <= "100";
		wait for 50  ns;
		KDU <= "000";		
		wait for 50  ns;						
     END PROCESS stim_process;
  --  End Test Bench 
  
END	behavioral;
