----------------------------------------------------------------------
--  CBP 09-01-23 :
--  ISE_IOPort_tb	 TestBench for IOPort
-----------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY IOPort_tb IS
END IOPort_tb;

ARCHITECTURE behavior OF IOPort_tb IS 
	COMPONENT IOPort is
    Port ( 
    load     : in std_logic;
    data_in  : in std_logic_vector(15 downto 0);
	data_out : out std_logic_vector(15 downto 0) 
	);             
	END COMPONENT;

    SIGNAL load      : std_logic;
    SIGNAL  data_in  :  std_logic_vector(15 downto 0); 
    SIGNAL  data_out :  std_logic_vector(15 downto 0); 

BEGIN
	uut: IOPort PORT MAP(
        load => load,
		data_in => data_in,
		data_out => data_out
	);

   tb_IOPort : PROCESS
   BEGIN
		load <= '0';
		wait for 100 ns;
		data_in <= X"3355";
		wait for 100 ns;
		load <= '1';
		data_in <= X"0011";
		wait for 100 ns;
		load <= '0';
		data_in <= X"0022";	
        wait for 100 ns;	
        data_in <= X"0033";	    
        load <= '1';    				
		wait;
   END PROCESS;
END;
