----------------------------------------------------------------------
--  CBP 22-01-23 :
--  ISE_RAM_tb	 TestBench for RAM
-----------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY RAM_tb IS
END RAM_tb;

ARCHITECTURE behavior OF RAM_tb IS 

	COMPONENT RAM is
    Port ( 
    clk      : in std_logic;
    addr_in  : in std_logic_vector(15 downto 0);
    data_in  : in std_logic_vector(15 downto 0);    
    data_out : out std_logic_vector(15 downto 0);
    mio      : in std_logic;
    mwe      : in std_logic
	);	
            
	END COMPONENT;

    signal clk      :  std_logic;
    signal addr_in  :  std_logic_vector(15 downto 0);
    signal data_in  :  std_logic_vector(15 downto 0);    
    signal data_out :  std_logic_vector(15 downto 0);
    signal mio      :  std_logic;
    signal mwe      :  std_logic;
            
BEGIN

	uut: RAM PORT MAP(
        clk => clk,
        addr_in => addr_in,
        data_in => data_in,
        data_out => data_out,
        mio => mio,
        mwe => mwe

	);
	
   tb_RAM : PROCESS
   BEGIN
     -- first a read from memory at addres 16 dec
     mwe <= '0';
     mio <= '0';
     wait for 100 ns;
     addr_in <= X"0010";
     wait for 100 ns;
     mio <= '1';
     wait for 200 ns;
     -- now a memory write
     addr_in <= X"0011";
     data_in <= X"0022";
     wait for 100 ns;
     mwe <= '1';
     -- and a read of what we have written
     wait for 100 ns;
     mwe <= '0';
     -- asset invalid address
     wait for 100ns;
     addr_in <= "UUUUUUUUUUUUUUUU";
     wait for 100 ns;
     mio <= '0';
          
   wait;
   
   END PROCESS;

	tb_clock : process
	begin
	  clk <= '0';
	  wait for 50 ns;
	  clk <= '1';
	  wait for 50 ns;
   end process;

END;
