----------------------------------------------------------------------
--  CBP 22-01-23 :
--  ISE_ALU_tb	 TestBench for ALU
-----------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY alu_tb IS
END alu_tb;

ARCHITECTURE behavior OF alu_tb IS 

	COMPONENT alu is
    Port ( 
	inA      : in std_logic_vector(15 downto 0);	
	inB      : in std_logic_vector(15 downto 0); 	
	sel_ALUf : in std_logic_vector(2 downto 0);	
	op       : out std_logic_vector(15 downto 0);	
	zero     : out std_logic
	);
	END COMPONENT;

    SIGNAL  inA      :  std_logic_vector(15 downto 0); 
    SIGNAL  inB      :  std_logic_vector(15 downto 0); 
    SIGNAL  sel_ALUf :  std_logic_vector(2 downto 0);
    SIGNAL  op       :  std_logic_vector(15 downto 0);   
    SIGNAL  zero     :  std_logic;
  
BEGIN

	uut: alu PORT MAP(
        inA => inA,
        inB => inB,
        sel_ALUf => sel_ALUf,
        op => op,
        zero => zero
	);
		
   tb_alu : PROCESS
   BEGIN
        inA <= X"0003";
        inB <= X"0002";
        wait for 100 ns;
        sel_ALUf <= "001";
        wait for 100 ns;
        sel_ALUf <= "010";
        wait for 100 ns;
        sel_ALUf <= "011";
        wait for 100 ns;
        sel_ALUf <= "100";
        wait for 100 ns;
        sel_ALUf <= "001";            
     wait;
   END PROCESS;

END;
