
----------------------------------------------------------------------
--
--  CBP 01-12-14 :
--
--  ISE_fsm_tb	 TestBench for cpu1
--
--  Full signal output
--
-----------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY fsm_tb IS
END fsm_tb;

ARCHITECTURE behavior OF fsm_tb IS 

	COMPONENT fsm is
    Port ( 
    reset : in std_logic;
    clk : in std_logic;
 --   abus : inout std_logic_vector(4 downto 0);
 --   dbus1 : inout std_logic_vector(15 downto 0);
 --   dbus2 : inout std_logic_vector(15 downto 0);
--    mio : inout std_logic;
 --   mwe : inout std_logic;

	-- registers
--	IR : inout std_logic_vector(15 downto 0); -- instruction register
--	IP : inout std_logic_vector(15 downto 0); -- instruction pointer
--	ACC : inout std_logic_vector(15 downto 0);	-- accumulator
	
	-- busses
--	alu_out : inout std_logic_vector(15 downto 0); -- ALU output
--	muxB_out : inout std_logic_vector(15 downto 0); -- Bmux output
--	muxA_out : inout std_logic_vector(15 downto 0); -- Amux output

--	zeroACC : inout std_logic;
	
    -- control unit
	cState : inout std_logic;	-- fetch/execute cState bit
	nState : in std_logic	-- next cState
--	ldIR : inout std_logic;	-- ldIR - load control signal
--	ldIP : inout std_logic;
--	ldACC : inout std_logic;
--	selMuxA : inout std_logic;
--	selMuxB : inout std_logic;
--	oeACC : inout std_logic;
--	sel_ALUf : inout std_logic_vector(2 downto 0)
	);
            
	END COMPONENT;

    SIGNAL reset : std_logic;
    SIGNAL clk : std_logic;
    SIGNAL  cstate :  std_logic;    -- fetch/execute state bit
	 signal nState : std_logic;
--    SIGNAL  selMuxA :  std_logic;
--    SIGNAL  selMuxB :  std_logic;

--    SIGNAL  ldIR :  std_logic;    -- ldIR - load control signal
--    SIGNAL  ldIP :  std_logic;
--    SIGNAL  ldACC :  std_logic;

--    SIGNAL  IR :  std_logic_vector(15 downto 0); -- instruction register
 --   SIGNAL  IP :  std_logic_vector(15 downto 0); -- program counter

 --   SIGNAL  alu_out :  std_logic_vector(15 downto 0); -- ALU output
 --   SIGNAL  muxB_out :  std_logic_vector(15 downto 0); -- Bmux output
 --   SIGNAL  muxA_out :  std_logic_vector(15 downto 0); -- Amux output
 --   SIGNAL  ACC :  std_logic_vector(15 downto 0);    -- accumulator

--    SIGNAL abus : std_logic_vector(4 downto 0);
 --   SIGNAL dbus1 : std_logic_vector(15 downto 0);
 --   SIGNAL dbus2 :  std_logic_vector(15 downto 0);
 --   SIGNAL mio :  std_logic;
 --   SIGNAL mwe :  std_logic;
 
 --   SIGNAL  zeroACC :  std_logic;

 --   signal  oeACC : std_logic;
--    SIGNAL  sel_ALUf :  std_logic_vector(2 downto 0);
      
           
BEGIN

	uut: fsm PORT MAP(
		reset => reset,
        clk => clk,
 --       selMuxA => selMuxA,
 --       selMuxB => selMuxB, 
--        abus => abus,
--        dbus1 => dbus1,
--        dbus2 => dbus2,
--        mio => mio,
--        mwe => mwe,
		
--        IR => IR,
--        IP => IP,
 --       ACC => ACC,
          -- datapath wires
 --       alu_out => alu_out,
 --       muxB_out => muxB_out,
 --       muxA_out => muxA_out,
 --       zeroACC => zeroACC,
           -- control unit
        cstate => cstate,
		  nState => nState
  --      ldIR => ldIR, 
  --      ldIP => ldIP,
 --       ldACC => ldACC,
 --       oeACC => oeACC,
 --       sel_ALUf => sel_ALUf
	);


    tb_clock : process
    begin
      clk <= '0';
      wait for 50 ns;
      clk <= '1';
      wait for 50 ns;
    end process;
	
   tb_reset : PROCESS
   BEGIN
      reset <= '1';
      wait for 210 ns;
      reset <= '0';
		wait for 210 ns;
		nState <= '1';
      wait;
   END PROCESS;

END;
