----------------------------------------------------------------------
--  CBP 22-01-23 :
--  ISE_mux_tb	 TestBench for mux
-----------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY mux_tb IS
END mux_tb;

ARCHITECTURE behavior OF mux_tb IS 

	COMPONENT mux is
    Port ( 
	inA : in std_logic_vector(15 downto 0); 
	inB : in std_logic_vector(15 downto 0); 
	op  : inout std_logic_vector(15 downto 0); 
	sel : in std_logic
	);	
            
	END COMPONENT;

    signal  inA :  std_logic_vector(15 downto 0); 
    signal  inB :  std_logic_vector(15 downto 0); 
    signal  op  :  std_logic_vector(15 downto 0); 
    signal  sel :  std_logic;

	 	   
BEGIN

	uut: mux PORT MAP(
        inA => inA,
        inB => inB,
        op => op,
        sel => sel
	);

  tb: PROCESS
   BEGIN
        inA <= X"0003";
        inB <= X"0005";
        wait for 100 ns;
        sel <= '0';
        wait for 100 ns;
        sel <= '1';
        wait for 100 ns;
        sel <= '0';
        wait for 200 ns;
        inA <= X"0000";
        inB <= X"0000";      
        wait;
   END PROCESS;

END;
