----------------------------------------------------------------------
--  CBP 22-01-23
--  ISE_reg_tb	 TestBench for register loading
-----------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY reg_tb IS
END reg_tb;

ARCHITECTURE behavior OF reg_tb IS 

	COMPONENT reg is
    Port ( 
    clk      : in std_logic;
    load     : in std_logic;
    data_in  : in std_logic_vector(15 downto 0);
    data_out : out std_logic_vector(15 downto 0)
	);
	END COMPONENT;

    SIGNAL clk       : std_logic;
    signal load      : std_logic;
    signal data_in   : std_logic_vector(15 downto 0);
    signal data_out  : std_logic_vector(15 downto 0);
            
BEGIN

	uut: reg PORT MAP(
        clk => clk,
        load => load,
        data_in => data_in,
        data_out => data_out
	);

    tb_clock : process
    begin
      clk <= '0';
      wait for 50 ns;
      clk <= '1';
      wait for 50 ns;
    end process;
	
   tb_reg : PROCESS
   BEGIN
     data_in <=X"0011";
     load <= '0';
     wait for 100 ns;
     load <= '1';
     wait for 100 ns;
     data_in <= X"0000";
     wait for 100 ns;
     data_in <= "UUUUUUUUUUUUUUUU";
     wait;
   END PROCESS;

END;
