----------------------------------------------------------------------
--
--  CBP 01-12-14
--
--  ISE_cpu1_1
--
--  Restructure for Student Template
--
-----------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity cpu1 is
    Port ( 
    reset : in std_logic;
    clk : in std_logic;
    abus : inout std_logic_vector(4 downto 0);
    dbus1 : inout std_logic_vector(15 downto 0);
    dbus2 : inout std_logic_vector(15 downto 0);
    mio : inout std_logic;
    mwe : inout std_logic;

	-- registers
	IR : inout std_logic_vector(15 downto 0); -- instruction register
	IP : inout std_logic_vector(15 downto 0); -- instruction pointer
	ACC : inout std_logic_vector(15 downto 0);	-- accumulator
	
	-- busses
	alu_out : inout std_logic_vector(15 downto 0); -- ALU output
	muxB_out : inout std_logic_vector(15 downto 0); -- Bmux output
	muxA_out : inout std_logic_vector(15 downto 0); -- Amux output

	zeroACC : inout std_logic;
	
    -- control unit
	cState : inout std_logic;	-- fetch/execute cState bit
	nState : inout std_logic;	-- next cState
	ldIR : inout std_logic;	-- ldIR - load control signal
	ldIP : inout std_logic;
	ldACC : inout std_logic;
	selMuxA : inout std_logic;
	selMuxB : inout std_logic;
	oeACC : inout std_logic;
	sel_ALUf : inout std_logic_vector(2 downto 0)
	);
		   
end cpu1;

architecture Behavioral of cpu1 is

-- memory declaration goes here -------------------------------------- 


begin
    

   -- ALU stuff ------------------------------------------------------



	-- FSM stuff ------------------------------------------------------

	FiniteStateMachine: process(reset, clk) 
	begin
		if (reset = '1') then
			cState <= '0';
		else 
			if (clk'event and clk = '1') then
				cState <= nState;
			end if;
		end if;
	end process;

   -- REGISTERS stuff ------------------------------------------------



	-- DATA and ADDRESS buses -----------------------------------------
	

	
	-- CONTROL UNIT ---------------------------------------------------
	
	
    
	-- MEMORY process -------------------------------------------------
            	


end Behavioral;
